/*
 * This file was generated by the Gradle 'init' task.
 *
 * This project uses @Incubating APIs which are subject to change.
 */

rootProject.name = "ArchGuard Scanner"

// common for share code repository
// TODO need to refactor as http, related https://github.com/archguard/archguard/issues/43, https://github.com/archguard/scanner/issues/3
include(":common_code_repository")

include(":diff_changes")

include(":doc_generator")

// standard doc model
include(":scanner_core")
include(":scanner_cli")

// official analyser implementations
include(
    ":analyser_template",
    ":analyser_sourcecode:lang_kotlin",
    ":analyser_sourcecode:lang_java",
    ":analyser_sourcecode:lang_typescript",
    ":analyser_sourcecode:lang_python",
    ":analyser_sourcecode:lang_golang",
    ":analyser_sourcecode:lang_csharp",
    ":analyser_sourcecode:lang_scala",
    ":analyser_sourcecode:feat_apicalls",
    ":analyser_sourcecode:feat_datamap",
)

// legacy scanners, should replace by analyser
include(":scan_git")
include(":scan_jacoco")
include(":scan_sourcecode")
include(":scan_sql")
include(":scan_test_badsmell")
include(":scan_bytecode")

include(":analyser_sca")

// core rule model
include(":rule_core")
include(":linter:rule_sql")
include(":linter:rule_test_code")
include(":linter:rule_webapi")
include(":linter:rule_code")
include(":linter:rule_template")

// adapter for ci
include(":collector_ci")
